/* Sample code using the Chunks and Tasks programming model.
 * See <http://www.chunks-and-tasks.org>.
 */
#include <stdexcept>
#include <cstring>
#include "SWResult.h"

CHT_CHUNK_TYPE_IMPLEMENTATION((SWResult));

void SWResult::writeToBuffer(char * dataBuffer, size_t const bufferSize) const {
  char* p = dataBuffer;
  memcpy(p, &maxValue, sizeof(int));
}

size_t SWResult::getSize() const {
  return sizeof(int);
}

void SWResult::assignFromBuffer(char const * dataBuffer, size_t const bufferSize) {
  const char* p = dataBuffer;
  memcpy(&maxValue, p, sizeof(int));
}

size_t SWResult::memoryUsage() const {
  return getSize();
}

cht::ChunkID SWResult::get_cid_H_bottom_row() const {
  cht::ChunkID cid_H_bottom_row;
  cht::ChunkID cid_H_rightmost_column;
  getChildren(cid_H_bottom_row, cid_H_rightmost_column);
  return cid_H_bottom_row;
}
cht::ChunkID SWResult::get_cid_H_rightmost_column() const {
  cht::ChunkID cid_H_bottom_row;
  cht::ChunkID cid_H_rightmost_column;
  getChildren(cid_H_bottom_row, cid_H_rightmost_column);
  return cid_H_rightmost_column;
}
